Index: ChangeLog
===================================================================
RCS file: /sources/cvs/ccvs/ChangeLog,v
retrieving revision 1.1296
diff -u -r1.1296 ChangeLog
--- ChangeLog	27 Apr 2006 18:42:25 -0000	1.1296
+++ ChangeLog	11 May 2006 00:39:16 -0000
@@ -1,3 +1,8 @@
+2006-05-10  Michael K. Sanders  <msanders@confusion.net>
+
+	* NEWS: Note new %a format character and new behavior of %{vV}
+	when UseNewInfoFmtStrings is enabled.
+
 2006-04-27  Derek Price  <derek@ximbiot.com>
 
 	* NEWS: Note that GSSAPI builds under HP-UX.
@@ -15,6 +20,19 @@
 
 	* m4/error.m4, m4/time_r.m4: Update from GNULIB.
 
+2006-04-04  Michael K. Sanders  <msanders@confusion.net>
+
+	* commit.c (check_fileproc): Set rev_old to "0" instead of NULL
+	when UseNewInfoFmtStrings.
+	(commit_fileproc): Set rev_new for removed files when
+	UseNewInfoFmtStrings.
+	(precommit_list_to_args_proc): Add %a format for file action
+	(status) to commitinfo.
+	* logmsg.c (logmsg_list_to_args_proc): Add %a format for file
+	action (status) to loginfo.
+	* sanity.sh (info): Update and expand tests for new %a format and
+	real version when UseNewInfoFmtStrings.
+
 2006-01-20  Derek Price  <derek@ximbiot.com>
 
 	* GPG-TODO: Note progress.
Index: NEWS
===================================================================
RCS file: /sources/cvs/ccvs/NEWS,v
retrieving revision 1.353
diff -u -r1.353 NEWS
--- NEWS	27 Apr 2006 18:42:25 -0000	1.353
+++ NEWS	11 May 2006 00:39:16 -0000
@@ -15,6 +15,12 @@
 * New admin options (--execute/--no-execute) have been added to modify
   the execute bits of files in the repository.  (CVS patch #4446.)
 
+* A new %a format character has been added to the commitinfo and loginfo
+  triggers which provides the file action (status).
+
+* When UseNewInfoFmtStrings is enabled, the %{vV} formats will now
+  expose the real version instead of NONE for added and removed files.
+
 BUG FIXES
 
 * The GSSAPI server should now build under HP-UX.
Index: doc/ChangeLog
===================================================================
RCS file: /sources/cvs/ccvs/doc/ChangeLog,v
retrieving revision 1.954
diff -u -r1.954 ChangeLog
--- doc/ChangeLog	24 Apr 2006 18:50:24 -0000	1.954
+++ doc/ChangeLog	11 May 2006 00:39:16 -0000
@@ -1,3 +1,8 @@
+2006-05-10  Michael K. Sanders  <msanders@confusion.net>
+
+	* cvs.texinfo (commitinfo, loginfo): Document new %a format
+	character.
+
 2006-01-20  Derek Price  <derek@ximbiot.com>
 
 	* cvsclient.text (Requests): Document Base-diff response.
Index: doc/cvs.texinfo
===================================================================
RCS file: /sources/cvs/ccvs/doc/cvs.texinfo,v
retrieving revision 1.680
diff -u -r1.680 cvs.texinfo
--- doc/cvs.texinfo	24 Apr 2006 18:50:25 -0000	1.680
+++ doc/cvs.texinfo	11 May 2006 00:39:17 -0000
@@ -13736,8 +13736,14 @@
 @file{commitinfo} supports:
 
 @table @t
-@item @{s@}
-a list of the names of files to be committed
+@item @{sa@}
+File attributes, where:
+@table @t
+@item s
+file name
+@item a
+file action (status)
+@end table
 @end table
 
 @cindex commitinfo (admin file), updating legacy repositories
@@ -14006,11 +14012,13 @@
 @file{loginfo} supports:
 
 @table @t
-@item @{stVv@}
+@item @{satVv@}
 File attributes, where:
 @table @t
 @item s
 file name
+@item a
+file action (status)
 @item T
 tag name of destination, or the empty string when there is no associated
 tag name (this usually means the trunk)
@@ -14022,7 +14030,7 @@
 @end table
 
 For example, some valid format strings are @samp{%%},
-@samp{%s}, @samp{%@{s@}}, and @samp{%@{stVv@}}.
+@samp{%s}, @samp{%@{s@}}, and @samp{%@{satVv@}}.
 
 @cindex loginfo (admin file), updating legacy repositories
 @cindex compatibility notes, loginfo admin file
Index: src/commit.c
===================================================================
RCS file: /sources/cvs/ccvs/src/commit.c,v
retrieving revision 1.259
diff -u -r1.259 commit.c
--- src/commit.c	24 Apr 2006 18:50:26 -0000	1.259
+++ src/commit.c	11 May 2006 00:39:17 -0000
@@ -1088,6 +1088,8 @@
 
 	    li->tag = xstrdup (vers->tag);
 	    li->rev_old = xstrdup (vers->vn_rcs);
+            if (li->rev_old == NULL && config->UseNewInfoFmtStrings)
+                li->rev_old = xstrdup ("0");
 	    li->rev_new = NULL;
 	    p->data = li;
 	    (void) addnode (ulist, p);
@@ -1218,6 +1220,24 @@
 		    arg = p->key;
 		}
 		break;
+            case 'a':
+                li = p->data;
+                switch (li->type)
+                {
+                    case T_ADDED:
+                        arg = "added";
+                        break;
+                    case T_MODIFIED:
+                        arg = "modified";
+                        break;
+                    case T_REMOVED:
+                        arg = "removed";
+                        break;
+                    case T_TITLE:
+                        arg = "imported";
+                        break;
+                }
+                break;
 	    default:
 		error (1, 0,
 		       "Unknown format character or not a list attribute: %c",
@@ -1296,7 +1316,7 @@
 #endif /* SERVER_SUPPORT */
 			      "p", "s", srepos,
 			      "r", "s", current_parsed_root->directory,
-			      "s", ",", ulist, precommit_list_to_args_proc,
+			      "sa", ",", ulist, precommit_list_to_args_proc,
 			      (void *) NULL,
 			      (char *) NULL);
 
@@ -1554,9 +1574,11 @@
            will return the version number of a file even after it has
            been removed from the archive, which is not the behavior we
            want for our commitlog messages; we want the old version
-           number and then "NONE." */
-
-	if (ci->status != T_REMOVED)
+           number and then "NONE, unless UseNewInfoFmtStrings has
+           been specified in the config.  Expose the real version in that
+           case and allow the trigger scripts to decide how to use it.  */
+            
+        if (ci->status != T_REMOVED || config->UseNewInfoFmtStrings)
 	{
 	    p = findnode (ulist, finfo->file);
 	    if (p)
Index: src/logmsg.c
===================================================================
RCS file: /sources/cvs/ccvs/src/logmsg.c,v
retrieving revision 1.101
diff -u -r1.101 logmsg.c
--- src/logmsg.c	24 Apr 2006 18:50:26 -0000	1.101
+++ src/logmsg.c	11 May 2006 00:39:17 -0000
@@ -644,6 +644,24 @@
 	    case 's':
 		arg = p->key;
 		break;
+            case 'a':
+                li = p->data;
+                switch (li->type)
+                {
+                    case T_ADDED:
+                        arg = "added";
+                        break;
+                    case T_MODIFIED:
+                        arg = "modified";
+                        break;
+                    case T_REMOVED:
+                        arg = "removed";
+                        break;
+                    case T_TITLE:
+                        arg = "imported";
+                        break;
+                }
+                break;
 	    case 'T':
 		li = p->data;
 		arg = li->tag ? li->tag : "";
@@ -768,6 +786,7 @@
        `}' as separators.  The format characters are:
 
          s = file name
+         a = file action (status)
 	 V = old version number (pre-checkin)
 	 v = new version number (post-checkin)
 
@@ -800,7 +819,8 @@
     /* %c = cvs_cmd_name
      * %p = shortrepos
      * %r = repository
-     * %{sVv} = file name, old revision (precommit), new revision (postcommit)
+     * %{saVv} = file name, file action (status)
+                 old revision (precommit), new revision (postcommit)
      */
     /*
      * Cast any NULL arguments as appropriate pointers as this is an
@@ -818,7 +838,7 @@
 #endif /* SERVER_SUPPORT */
 	                      "p", "s", srepos,
 	                      "r", "s", current_parsed_root->directory,
-	                      "sTVv", ",", changes,
+	                      "saTVv", ",", changes,
 			      logmsg_list_to_args_proc, (void *) NULL,
 	                      (char *) NULL);
     if (!cmdline || !strlen (cmdline))
Index: src/sanity.sh
===================================================================
RCS file: /sources/cvs/ccvs/src/sanity.sh,v
retrieving revision 1.1136
diff -u -r1.1136 sanity.sh
--- src/sanity.sh	1 May 2006 20:38:28 -0000	1.1136
+++ src/sanity.sh	11 May 2006 00:39:19 -0000
@@ -3091,7 +3091,7 @@
 PrimaryServer=$PRIMARY_CVSROOT
 EOF
     cat >>loginfo <<EOF
-ALL $TESTDIR/sync-secondary loginfo %c %p %{sVv}
+ALL $TESTDIR/sync-secondary loginfo %c %p %{saVv}
 EOF
     cat >>postadmin <<EOF
 ALL $TESTDIR/sync-secondary postadmin %c %p
@@ -19067,7 +19067,8 @@
           echo "ALL echo %{} >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
           echo "ALL echo %x >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
           echo "ALL echo % >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
-          echo "ALL echo %{sxVv} >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
+          echo "ALL echo %{saxVv} >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
+          echo "ALL echo %{a} >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
           echo "ALL echo %{v} >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
           echo "ALL echo %s %s >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
           echo "ALL echo %{V}AX >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
@@ -19151,6 +19152,33 @@
 and set UseNewInfoFmtStrings=yes in CVSROOT/config\.  After that, convert
 individual command lines and scripts to handle the new format at your
 leisure\."
+          rm file1
+	  dotest info-8 "${testcvs} -q rm -f file1" \
+"${SPROG} remove: use .${SPROG} commit. to remove this file permanently"
+	  dotest info-8a "${testcvs} -q ci -m remove-it" \
+"$TESTDIR/cvsroot/first-dir/file1,v  <--  file1
+new revision: delete; previous revision: 1\.3
+$SPROG commit: loginfo:[0-9]*: no such user variable \${=ZEE}
+$SPROG commit: warning:  Set to use deprecated info format strings\.  Establish
+compatibility with the new info file format strings (add a temporary .1. in
+all info files after each .%. which doesn.t represent a literal percent)
+and set UseNewInfoFmtStrings=yes in CVSROOT/config\.  After that, convert
+individual command lines and scripts to handle the new format at your
+leisure\."
+          echo "resurrected file1" >file1
+	  dotest info-8b "$testcvs add file1" \
+"$SPROG add: Re-adding file \`file1' after dead revision 1\.4\.
+$SPROG add: use \`$SPROG commit' to add this file permanently"
+	  dotest info-8c "${testcvs} -q ci -m add-it" \
+"$TESTDIR/cvsroot/first-dir/file1,v  <--  file1
+new revision: 1.5; previous revision: 1\.4
+$SPROG commit: loginfo:[0-9]*: no such user variable \${=ZEE}
+$SPROG commit: warning:  Set to use deprecated info format strings\.  Establish
+compatibility with the new info file format strings (add a temporary .1. in
+all info files after each .%. which doesn.t represent a literal percent)
+and set UseNewInfoFmtStrings=yes in CVSROOT/config\.  After that, convert
+individual command lines and scripts to handle the new format at your
+leisure\."
 
 	  cd ..
 	  dotest info-9 "cat $TESTDIR/testlog" \
@@ -19159,7 +19187,8 @@
 'first-dir
 first-dir
 first-dir
-first-dir file1,,NONE,1.1
+first-dir file1,added,,NONE,1.1
+first-dir added
 first-dir 1.1
 first-dir file1 %s
 first-dir NONEAX
@@ -19167,7 +19196,8 @@
 first-dir
 first-dir
 first-dir
-first-dir file1,,1.1,1.2
+first-dir file1,modified,,1.1,1.2
+first-dir modified
 first-dir 1.2
 first-dir file1 %s
 first-dir 1.1AX
@@ -19175,10 +19205,29 @@
 first-dir
 first-dir
 first-dir
-first-dir file1,,1.2,1.3
+first-dir file1,modified,,1.2,1.3
+first-dir modified
 first-dir 1.3
 first-dir file1 %s
 first-dir 1.2AX
+first-dir file1ux
+first-dir
+first-dir
+first-dir
+first-dir file1,removed,,1.3,NONE
+first-dir removed
+first-dir NONE
+first-dir file1 %s
+first-dir 1.3AX
+first-dir file1ux
+first-dir
+first-dir
+first-dir
+first-dir file1,added,,1.4,1.5
+first-dir added
+first-dir 1.5
+first-dir file1 %s
+first-dir 1.4AX
 first-dir file1ux'
 
 	  # and make sure adding a '1' in the format strings really does ensure
@@ -19196,7 +19245,8 @@
           echo "ALL echo %1{} >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
           echo "ALL echo %1x >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
           echo "ALL echo %1 >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
-          echo "ALL echo %1{sxVv} >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
+          echo "ALL echo %1{saxVv} >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
+          echo "ALL echo %1{a} >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
           echo "ALL echo %1{v} >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
           echo "ALL echo %1s %%s >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
           echo "ALL echo %1{V}AX >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
@@ -19248,6 +19298,8 @@
 ${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
 the new argument format and remove '1's from your info file format strings\.
 ${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
 the new argument format and remove '1's from your info file format strings\."
 	  echo line0 >>file1
 	  dotest info-intfmt-6c "${testcvs} -q -sOTHER=foo ci -m mod-it" \
@@ -19269,6 +19321,8 @@
 ${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
 the new argument format and remove '1's from your info file format strings\.
 ${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
 the new argument format and remove '1's from your info file format strings\."
 	  echo line1 >>file1
 	  dotest info-intfmt-7 "${testcvs} -q -s OTHER=value -s ZEE=z ci -m mod-it" \
@@ -19289,6 +19343,59 @@
 ${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
 the new argument format and remove '1's from your info file format strings\.
 ${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\."
+          rm file1
+	  dotest info-intfmt-8 "${testcvs} -q rm -f file1" \
+"${SPROG} remove: use .${SPROG} commit. to remove this file permanently"
+	  dotest info-intfmt-8a "${testcvs} -q ci -m remove-it" \
+"$TESTDIR/cvsroot/third-dir/file1,v  <--  file1
+new revision: delete; previous revision: 1\.3
+${SPROG} commit: loginfo:[0-9]*: no such user variable \${=ZEE}
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\."
+          echo "resurrected file1" >file1
+	  dotest info-8b "$testcvs add file1" \
+"$SPROG add: Re-adding file \`file1' after dead revision 1\.4\.
+$SPROG add: use \`$SPROG commit' to add this file permanently"
+	  dotest info-8c "${testcvs} -q ci -m add-it" \
+"$TESTDIR/cvsroot/third-dir/file1,v  <--  file1
+new revision: 1.5; previous revision: 1\.4
+${SPROG} commit: loginfo:[0-9]*: no such user variable \${=ZEE}
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
+the new argument format and remove '1's from your info file format strings\.
+${SPROG} commit: Using deprecated info format strings\.  Convert your scripts to use
 the new argument format and remove '1's from your info file format strings\."
 
 	  cd ..
@@ -19297,15 +19404,17 @@
 'third-dir
 third-dir
 third-dir
-third-dir file1,,NONE,1.1
+third-dir file1,added,,0,1.1
+third-dir added
 third-dir 1.1
 third-dir file1 %s
-third-dir NONEAX
+third-dir 0AX
 third-dir file1ux
 third-dir
 third-dir
 third-dir
-third-dir file1,,1.1,1.2
+third-dir file1,modified,,1.1,1.2
+third-dir modified
 third-dir 1.2
 third-dir file1 %s
 third-dir 1.1AX
@@ -19313,10 +19422,29 @@
 third-dir
 third-dir
 third-dir
-third-dir file1,,1.2,1.3
+third-dir file1,modified,,1.2,1.3
+third-dir modified
 third-dir 1.3
 third-dir file1 %s
 third-dir 1.2AX
+third-dir file1ux
+third-dir
+third-dir
+third-dir
+third-dir file1,removed,,1.3,1.4
+third-dir removed
+third-dir 1.4
+third-dir file1 %s
+third-dir 1.3AX
+third-dir file1ux
+third-dir
+third-dir
+third-dir
+third-dir file1,added,,1.4,1.5
+third-dir added
+third-dir 1.5
+third-dir file1 %s
+third-dir 1.4AX
 third-dir file1ux'
 
 	  rm ${TESTDIR}/testlog ${TESTDIR}/testlog2
@@ -19326,7 +19454,8 @@
 	  dotest info-setup-newfmt-1 "$testcvs -q up -prinfo-start loginfo >loginfo"
 	  echo "ALL sh -c \"echo x\${=MYENV}\${=OTHER}y\${=ZEE}=\$USER=\$CVSROOT= >>$TESTDIR/testlog; cat >/dev/null\" %{sVv}" >> loginfo
           # The following cases test the format string substitution
-          echo "ALL echo %p \"%{sTVv}\" >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
+          echo "ALL echo %p \"%{saTVv}\" >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
+          echo "ALL echo %a >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
           echo "ALL echo %T >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
           echo "ALL echo %{v} >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
           echo "ALL echo %s >>$TESTDIR/testlog2; cat >/dev/null" >> loginfo
@@ -19363,26 +19492,56 @@
 	  dotest info-newfmt-5 "${testcvs} -q -s OTHER=value -s ZEE=z ci -m mod-it" \
 "${TESTDIR}/cvsroot/fourth-dir/file1,v  <--  file1
 new revision: 1\.3; previous revision: 1\.2"
+          rm file1
+          dotest info-newfmt-5a "${testcvs} -q rm -f file1" \
+"${SPROG} remove: use .${SPROG} commit. to remove this file permanently"
+          dotest info-newfmt-5b "${testcvs} -q  ci -m remove-it" \
+"$TESTDIR/cvsroot/fourth-dir/file1,v  <--  file1
+new revision: delete; previous revision: 1\.3
+$SPROG commit: loginfo:[0-9]*: no such user variable \${=ZEE}"
+          echo "resurrected file1" >file1
+          dotest info-newfmt-5c "$testcvs add file1" \
+"$SPROG add: Re-adding file \`file1' after dead revision 1\.4\.
+$SPROG add: use \`$SPROG commit' to add this file permanently"
+          dotest info-newfmt-5d "${testcvs} -q ci -m add-it" \
+"$TESTDIR/cvsroot/fourth-dir/file1,v  <--  file1
+new revision: 1.5; previous revision: 1\.4
+$SPROG commit: loginfo:[0-9]*: no such user variable \${=ZEE}"
 
 	  cd ..
 	  dotest info-newfmt-6 "cat $TESTDIR/testlog" \
 "xenv-valueyz=${username}=${TESTDIR}/cvsroot="
           dotest info-newfmt-7 "cat $TESTDIR/testlog2" \
-'fourth-dir file1  NONE 1\.1
+'fourth-dir file1 added  0 1\.1
+added
 
 1\.1
 file1
-NONEAX
-fourth-dir file1  1\.1 1\.2
+0AX
+fourth-dir file1 modified  1\.1 1\.2
+modified
 
 1\.2
 file1
 1\.1AX
-fourth-dir file1  1\.2 1\.3
+fourth-dir file1 modified  1\.2 1\.3
+modified
 
 1\.3
 file1
-1\.2AX'
+1\.2AX
+fourth-dir file1 removed  1\.3 1\.4
+removed
+
+1\.4
+file1
+1\.3AX
+fourth-dir file1 added  1\.4 1\.5
+added
+
+1\.5
+file1
+1\.4AX'
 
 	  # clean up after newfmt tests
 	  cd CVSROOT
@@ -19444,7 +19603,7 @@
 	  cd ../first-dir
 	  echo line2 >>file1
 	  dotest_fail info-v2 "${testcvs} -q ci -m bogus" \
-"vscript $tempname file1 1\.3
+"vscript $tempname file1 1\.5
 No BugId found\.
 ${SPROG} \[commit aborted\]: Message verification failed"
 
@@ -19453,9 +19612,9 @@
 and many more lines after it
 EOF
 	  dotest info-v3 "${testcvs} -q ci -F ${TESTDIR}/comment.tmp" \
-"vscript $tempname file1 1\.3
+"vscript $tempname file1 1\.5
 $CVSROOT_DIRNAME/first-dir/file1,v  <--  file1
-new revision: 1\.4; previous revision: 1\.3"
+new revision: 1\.6; previous revision: 1\.5"
 	  rm ${TESTDIR}/comment.tmp
 
 	  cd ..
@@ -19539,10 +19698,10 @@
 See what happens next.
 EOF
 	  dotest info-reread-2 "${testcvs} -q ci -F ${TESTDIR}/comment.tmp" \
-"vscript $tempname file1 1\.4
+"vscript $tempname file1 1\.6
 $CVSROOT_DIRNAME/first-dir/file1,v  <--  file1
-new revision: 1\.5; previous revision: 1\.4"
-	  dotest info-reread-3 "${testcvs} -q log -N -r1.5 file1" "
+new revision: 1\.7; previous revision: 1\.6"
+	  dotest info-reread-3 "${testcvs} -q log -N -r1.7 file1" "
 .*
 BugId: new
 See what happens next.
@@ -19565,10 +19724,10 @@
 See what happens next with stat.
 EOF
 	  dotest info-reread-5 "${testcvs} -q ci -F ${TESTDIR}/comment.tmp" \
-"vscript $tempname file1 1\.5
+"vscript $tempname file1 1\.7
 $CVSROOT_DIRNAME/first-dir/file1,v  <--  file1
-new revision: 1\.6; previous revision: 1\.5"
-	  dotest info-reread-6 "${testcvs} -q log -N -r1.6 file1" "
+new revision: 1\.8; previous revision: 1\.7"
+	  dotest info-reread-6 "${testcvs} -q log -N -r1.8 file1" "
 .*
 BugId: new
 See what happens next with stat.
@@ -19591,10 +19750,10 @@
 See what happens next.
 EOF
 	  dotest info-reread-8 "${testcvs} -q ci -F ${TESTDIR}/comment.tmp" \
-"vscript $tempname file1 1\.6
+"vscript $tempname file1 1\.8
 $CVSROOT_DIRNAME/first-dir/file1,v  <--  file1
-new revision: 1\.7; previous revision: 1\.6"
-	  dotest info-reread-6 "${testcvs} -q log -N -r1.7 file1" "
+new revision: 1\.9; previous revision: 1\.8"
+	  dotest info-reread-6 "${testcvs} -q log -N -r1.9 file1" "
 .*
 BugId: new
 See what happens next.