diff -Naur /users/iupisi/isi2g0/TP_JUnit/Depot/Opale/src/units/matrix/TestBandMatrix.java Opale/src/units/matrix/TestBandMatrix.java
--- /users/iupisi/isi2g0/TP_JUnit/Depot/Opale/src/units/matrix/TestBandMatrix.java
+++ Opale/src/units/matrix/TestBandMatrix.java	Fri Feb 20 15:40:01 2004
@@ -0,0 +1,157 @@
+/*
+ * OPALE is a scientific library under LGPL. Its main goal is to
+ * develop mathematical tools for any scientist.
+ *
+ * Copyright (C) 2002 Opale Group
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * You can visit the web site http://opale.tuxfamily.org to obtain more
+ * informations about this program and/or to contact the authors by mail
+ * developers@opale.tuxfamily.org.
+ */
+
+
+package matrix;
+
+import junit.framework.TestCase;
+import opale.matrix.BandMatrix;
+import java.util.Vector;
+import opale.mathtools.DVect;
+
+
+public class TestBandMatrix extends TestCase
+{
+	public void testConstructors()
+	{
+		BandMatrix m1 = new BandMatrix(2,3);
+		assertTrue(m1.getSize()==2 && m1.getSizeOfBand()==3);
+		assertTrue(m1.get(0,0)==0);
+		assertTrue(m1.get(0,1)==0);
+		assertTrue(m1.get(0,2)==0);
+		assertTrue(m1.get(1,0)==0);
+		assertTrue(m1.get(1,1)==0);
+		assertTrue(m1.get(1,2)==0);
+                
+	}
+
+	public void testSet()
+	{
+		BandMatrix m1 = new BandMatrix(2,3);
+                
+                // surement erreur de dépassement de bande
+                // répercussion sur le add
+                m1.set(0,0,0.1);
+                m1.set(0,1,0.2);
+                m1.set(0,2,0.3);
+                m1.set(1,0,0.4);
+                m1.set(1,1,0.5);
+                m1.set(1,2,0.6);
+
+                System.out.println ("0,0 = "+m1.get(0,0));
+                System.out.println ("0,1 = "+m1.get(0,1));
+                System.out.println ("0,2 = "+m1.get(0,2));
+                System.out.println ("1,0 = "+m1.get(1,0));
+                System.out.println ("1,1 = "+m1.get(1,1));
+                System.out.println ("1,2 = "+m1.get(1,2));
+                
+		assertTrue(m1.get(0,0)==0.1);
+		assertTrue(m1.get(0,1)==0.2);
+		assertTrue(m1.get(0,2)==0.3);
+		assertTrue(m1.get(1,0)==0.4);
+		assertTrue(m1.get(1,1)==0.5);
+		assertTrue(m1.get(1,2)==0.6);
+	}
+
+	public void testAdd()
+	{
+                // erreur provenant du set
+		BandMatrix m1 = new BandMatrix(2,3);
+                m1.set(0,0,0.1);
+                m1.set(0,1,0.2);
+                m1.set(0,2,0.3);
+                m1.set(1,0,0.4);
+                m1.set(1,1,0.5);
+                m1.set(1,2,0.6);
+
+		BandMatrix m2 = new BandMatrix(2,3);
+                m2.set(0,0,1.9);
+                m2.set(0,1,1.8);
+                m2.set(0,2,1.7);
+                m2.set(1,0,1.6);
+                m2.set(1,1,1.5);
+                m2.set(1,2,1.4);
+
+                m1.add(m2) ;
+
+                System.out.println ("0,0 = "+m1.get(0,0));
+                System.out.println ("0,1 = "+m1.get(0,1));
+                System.out.println ("0,2 = "+m1.get(0,2));
+                System.out.println ("1,0 = "+m1.get(1,0));
+                System.out.println ("1,1 = "+m1.get(1,1));
+                System.out.println ("1,2 = "+m1.get(1,2));
+
+		assertTrue(m1.get(0,0)==2.0);
+		assertTrue(m1.get(0,1)==2.0);
+		assertTrue(m1.get(0,2)==2.0);
+		assertTrue(m1.get(1,0)==2.0);
+		assertTrue(m1.get(1,1)==2.0);
+		assertTrue(m1.get(1,2)==2.0);
+                
+                m1.add(0,0, 1.1) ;
+                m1.add(0,1, 1.2) ;
+                m1.add(0,2, 1.3) ;
+                m1.add(1,0, 1.4) ;
+                m1.add(1,1, 1.5) ;
+                m1.add(1,2, 1.6) ;
+
+                System.out.println ("0,0 = "+m1.get(0,0));
+                System.out.println ("0,1 = "+m1.get(0,1));
+                System.out.println ("0,2 = "+m1.get(0,2));
+                System.out.println ("1,0 = "+m1.get(1,0));
+                System.out.println ("1,1 = "+m1.get(1,1));
+                System.out.println ("1,2 = "+m1.get(1,2));
+
+		assertTrue(m1.get(0,0)==3.1);
+		assertTrue(m1.get(0,1)==3.2);
+		assertTrue(m1.get(0,2)==3.3);
+		assertTrue(m1.get(1,0)==3.4);
+		assertTrue(m1.get(1,1)==3.5);
+		assertTrue(m1.get(1,2)==3.6);
+	}
+
+	public void testMul()
+	{
+                DVect v = new DVect (2) ;
+                v.set (0, 1.0) ;
+                v.set (1, 2.0) ;
+                
+		BandMatrix m1 = new BandMatrix(2,3);
+                m1.set(0,0,0.1);
+                m1.set(0,1,0.2);
+                m1.set(0,2,0.3);
+                m1.set(1,0,0.4);
+                m1.set(1,1,0.5);
+                m1.set(1,2,0.6);
+                
+                v = m1.mul(v) ;
+
+                System.out.println ("0,0 = "+v.get(0));
+                System.out.println ("0,1 = "+v.get(1));
+                
+		assertTrue(v.get(0)==0.5);
+		assertTrue(v.get(1)==1.4);
+	}
+}