Index: src/playerlist.cpp
===================================================================
--- src/playerlist.cpp	(revision 1773)
+++ src/playerlist.cpp	(working copy)
@@ -364,7 +364,7 @@
       for (unsigned int j = 0; j < MAX_PLAYERS; j++)
 	{
 	  if (deplete[j] == i)
-	    titles[j] = _("");
+	    titles[j] = "";
 	}
     }
   for (unsigned int i = 0; i < MAX_PLAYERS; i++)
Index: src/gui/ruin-report-dialog.cpp
===================================================================
--- src/gui/ruin-report-dialog.cpp	(revision 1773)
+++ src/gui/ruin-report-dialog.cpp	(working copy)
@@ -162,9 +162,9 @@
 		case 5: case 4: case 3: case 2: case 1: 
 		  hint += _("It is guarded."); break;
 		case 0: 
-		  hint += _(""); break;
+		  hint += ""; break;
 		default: 
-		  hint += _(""); break;
+		  hint += ""; break;
 		}
 	    }
 	  else
Index: src/gui/main.cpp
===================================================================
--- src/gui/main.cpp	(revision 1773)
+++ src/gui/main.cpp	(working copy)
@@ -63,7 +63,7 @@
     {
 	impl->gtk_main.reset(new Gtk::Main(argc, argv));
 
-	g_set_application_name(_("LordsAWar!"));
+	g_set_application_name("LordsAWar!");
 
 	Timing::instance().timer_registered.connect(
 	    sigc::mem_fun(*impl, &Main::Impl::on_timer_registered));
Index: src/main.cpp
===================================================================
--- src/main.cpp	(revision 1773)
+++ src/main.cpp	(working copy)
@@ -46,11 +46,17 @@
   initialize_configuration();
   RecentlyPlayedGameList::getInstance()->loadFromFile(File::getSavePath() + "/recently-played.xml");
 
-  setlocale(LC_ALL, Configuration::s_lang.c_str());
+  #if ENABLE_NLS
+  cout << "Configuration::s_lang.c_str(): " << Configuration::s_lang.c_str() << endl;
+  //cout << "setlocale: " << setlocale(LC_ALL, Configuration::s_lang.c_str()) << endl;  //Not working?
+  cout << "setlocale: " << setlocale(LC_ALL, "") << endl;
+  cout << "bindtextdomain: " << bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR) << endl;
+  cout << "bind_textdomain_codeset: " << bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8") << endl;
+  cout << "textdomain: " << textdomain (GETTEXT_PACKAGE) << endl;
+  #endif
 
   Main kit(argc, argv);
 
-  textdomain ("lordsawar");
   if (argc > 1)
     {
       for (int i = 2; i <= argc; i++)
Index: dat/glade/game-preferences-dialog.glade
===================================================================
--- dat/glade/game-preferences-dialog.glade	(revision 1773)
+++ dat/glade/game-preferences-dialog.glade	(working copy)
@@ -265,7 +265,7 @@
 		      <child>
 			<widget class="GtkLabel" id="difficulty_label">
 			  <property name="visible">True</property>
-			  <property name="label" translatable="yes">###%</property>
+			  <property name="label">###%</property>
 			  <property name="use_underline">False</property>
 			  <property name="use_markup">False</property>
 			  <property name="justify">GTK_JUSTIFY_LEFT</property>
Index: dat/glade/about-dialog.glade
===================================================================
--- dat/glade/about-dialog.glade	(revision 1773)
+++ dat/glade/about-dialog.glade	(working copy)
@@ -7,7 +7,7 @@
   <property name="border_width">5</property>
   <property name="visible">True</property>
   <property name="destroy_with_parent">False</property>
-  <property name="name" translatable="yes">LordsAWar!</property>
+  <property name="name">LordsAWar!</property>
   <property name="copyright" translatable="yes"></property>
   <property name="comments" translatable="yes">Freedom is the most important 
 feature of this game.</property>
Index: dat/glade/game-window.glade
===================================================================
--- dat/glade/game-window.glade	(revision 1773)
+++ dat/glade/game-window.glade	(working copy)
@@ -4,7 +4,7 @@
 <glade-interface>
 
 <widget class="GtkWindow" id="window">
-  <property name="title" translatable="yes">LordsAWar!</property>
+  <property name="title">LordsAWar!</property>
   <property name="type">GTK_WINDOW_TOPLEVEL</property>
   <property name="window_position">GTK_WIN_POS_NONE</property>
   <property name="modal">False</property>
Index: dat/glade/splash-window.glade
===================================================================
--- dat/glade/splash-window.glade	(revision 1773)
+++ dat/glade/splash-window.glade	(working copy)
@@ -4,7 +4,7 @@
 <glade-interface>
 
 <widget class="GtkWindow" id="window">
-  <property name="title" translatable="yes">LordsAWar!</property>
+  <property name="title">LordsAWar!</property>
   <property name="type">GTK_WINDOW_TOPLEVEL</property>
   <property name="window_position">GTK_WIN_POS_NONE</property>
   <property name="modal">False</property>
Index: po/LINGUAS
===================================================================
--- po/LINGUAS	(revision 1773)
+++ po/LINGUAS	(working copy)
@@ -3,4 +3,4 @@
 # This file is in the public domain.
 #
 # Set of available languages.
-it de hi pl fr
+#it de hi pl fr
+de